# coding: utf-8

"""
    VMware Aria Automation Assembler IaaS API

    IAAS API is a RESTful service, which allows users to execute provisioning related UI actions via an API.  This page describes the RESTful APIs for IAAS API. The APIs facilitate CRUD operations on the various resources and entities used throughout VMware Aria Automation Assembler(Cloud Accounts, Cloud zones, Computes, Mappings, etc.) and allows operations on them (creating a cloud account, patching a machine, creating image progile, etc.).  The APIs that list collections of resources also support OData like implementation. Below query params can be used across different IAAS API endpoints  Example: 1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.     ```/iaas/api/cloud-accounts?$orderby=name%20desc```  2. `$top` -  number of records you want to get.     ```/iaas/api/cloud-accounts?$top=20```  3. `$skip` -  number of records you want to skip.      ```/iaas/api/cloud-accounts?$skip=10```  4. `$select` - select a subset of properties to include in the response.        ```/project-service/api/projects?$top=10&$skip=2```  5. `$filter` -  filter the results by a specified predicate expression. Operators: eq, ne, and, or.\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'ABC*'``` - name starts with 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'*ABC*'``` - name contains 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'*ABC'``` - name ends with 'ABC'\\     /iaas/api/projects and /iaas/api/deployments support different format for partial match:\\     ```/iaas/api/projects?$filter=startswith(name, 'ABC')``` - name starts with 'ABC'\\     ```/iaas/api/projects?$filter=substringof('ABC', name``` - name contains 'ABC'\\     ```/iaas/api/projects?$filter=endswith(name, 'ABC')``` - name ends with 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20ne%20'example-cloud-account'%20or%20customProperties.isExternal%20eq%20'false'```  6. `$count` -  flag which when specified, regardless of the assigned value, shows the total number of records. If the collection has a filter it shows the number of records matching the filter.\\     ```/iaas/api/cloud-accounts?$count=true```   # noqa: E501

    OpenAPI spec version: 2021-07-15
    Contact: sales@vmware.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class CloudAccountAzureSpecification(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'description': 'str',
        'subscription_id': 'str',
        'tenant_id': 'str',
        'client_application_id': 'str',
        'client_application_secret_key': 'str',
        'regions': 'list[IaasapicloudaccountsvsphereRegions]',
        'create_default_zones': 'bool',
        'tags': 'list[IaasapistorageprofilesidTags]'
    }

    attribute_map = {
        'name': 'name',
        'description': 'description',
        'subscription_id': 'subscriptionId',
        'tenant_id': 'tenantId',
        'client_application_id': 'clientApplicationId',
        'client_application_secret_key': 'clientApplicationSecretKey',
        'regions': 'regions',
        'create_default_zones': 'createDefaultZones',
        'tags': 'tags'
    }

    def __init__(self, name=None, description=None, subscription_id=None, tenant_id=None, client_application_id=None, client_application_secret_key=None, regions=None, create_default_zones=None, tags=None):  # noqa: E501
        """CloudAccountAzureSpecification - a model defined in Swagger"""  # noqa: E501
        self._name = None
        self._description = None
        self._subscription_id = None
        self._tenant_id = None
        self._client_application_id = None
        self._client_application_secret_key = None
        self._regions = None
        self._create_default_zones = None
        self._tags = None
        self.discriminator = None
        self.name = name
        if description is not None:
            self.description = description
        self.subscription_id = subscription_id
        self.tenant_id = tenant_id
        self.client_application_id = client_application_id
        self.client_application_secret_key = client_application_secret_key
        self.regions = regions
        if create_default_zones is not None:
            self.create_default_zones = create_default_zones
        if tags is not None:
            self.tags = tags

    @property
    def name(self):
        """Gets the name of this CloudAccountAzureSpecification.  # noqa: E501

        A human-friendly name used as an identifier in APIs that support this option.  # noqa: E501

        :return: The name of this CloudAccountAzureSpecification.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this CloudAccountAzureSpecification.

        A human-friendly name used as an identifier in APIs that support this option.  # noqa: E501

        :param name: The name of this CloudAccountAzureSpecification.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def description(self):
        """Gets the description of this CloudAccountAzureSpecification.  # noqa: E501

        A human-friendly description.  # noqa: E501

        :return: The description of this CloudAccountAzureSpecification.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this CloudAccountAzureSpecification.

        A human-friendly description.  # noqa: E501

        :param description: The description of this CloudAccountAzureSpecification.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def subscription_id(self):
        """Gets the subscription_id of this CloudAccountAzureSpecification.  # noqa: E501

        Azure Subscribtion ID  # noqa: E501

        :return: The subscription_id of this CloudAccountAzureSpecification.  # noqa: E501
        :rtype: str
        """
        return self._subscription_id

    @subscription_id.setter
    def subscription_id(self, subscription_id):
        """Sets the subscription_id of this CloudAccountAzureSpecification.

        Azure Subscribtion ID  # noqa: E501

        :param subscription_id: The subscription_id of this CloudAccountAzureSpecification.  # noqa: E501
        :type: str
        """
        if subscription_id is None:
            raise ValueError("Invalid value for `subscription_id`, must not be `None`")  # noqa: E501

        self._subscription_id = subscription_id

    @property
    def tenant_id(self):
        """Gets the tenant_id of this CloudAccountAzureSpecification.  # noqa: E501

        Azure Tenant ID  # noqa: E501

        :return: The tenant_id of this CloudAccountAzureSpecification.  # noqa: E501
        :rtype: str
        """
        return self._tenant_id

    @tenant_id.setter
    def tenant_id(self, tenant_id):
        """Sets the tenant_id of this CloudAccountAzureSpecification.

        Azure Tenant ID  # noqa: E501

        :param tenant_id: The tenant_id of this CloudAccountAzureSpecification.  # noqa: E501
        :type: str
        """
        if tenant_id is None:
            raise ValueError("Invalid value for `tenant_id`, must not be `None`")  # noqa: E501

        self._tenant_id = tenant_id

    @property
    def client_application_id(self):
        """Gets the client_application_id of this CloudAccountAzureSpecification.  # noqa: E501

        Azure Client Application ID  # noqa: E501

        :return: The client_application_id of this CloudAccountAzureSpecification.  # noqa: E501
        :rtype: str
        """
        return self._client_application_id

    @client_application_id.setter
    def client_application_id(self, client_application_id):
        """Sets the client_application_id of this CloudAccountAzureSpecification.

        Azure Client Application ID  # noqa: E501

        :param client_application_id: The client_application_id of this CloudAccountAzureSpecification.  # noqa: E501
        :type: str
        """
        if client_application_id is None:
            raise ValueError("Invalid value for `client_application_id`, must not be `None`")  # noqa: E501

        self._client_application_id = client_application_id

    @property
    def client_application_secret_key(self):
        """Gets the client_application_secret_key of this CloudAccountAzureSpecification.  # noqa: E501

        Azure Client Application Secret Key  # noqa: E501

        :return: The client_application_secret_key of this CloudAccountAzureSpecification.  # noqa: E501
        :rtype: str
        """
        return self._client_application_secret_key

    @client_application_secret_key.setter
    def client_application_secret_key(self, client_application_secret_key):
        """Sets the client_application_secret_key of this CloudAccountAzureSpecification.

        Azure Client Application Secret Key  # noqa: E501

        :param client_application_secret_key: The client_application_secret_key of this CloudAccountAzureSpecification.  # noqa: E501
        :type: str
        """
        if client_application_secret_key is None:
            raise ValueError("Invalid value for `client_application_secret_key`, must not be `None`")  # noqa: E501

        self._client_application_secret_key = client_application_secret_key

    @property
    def regions(self):
        """Gets the regions of this CloudAccountAzureSpecification.  # noqa: E501

        A set of regions to enable provisioning on.Refer to /iaas/api/cloud-accounts/region-enumeration.  # noqa: E501

        :return: The regions of this CloudAccountAzureSpecification.  # noqa: E501
        :rtype: list[IaasapicloudaccountsvsphereRegions]
        """
        return self._regions

    @regions.setter
    def regions(self, regions):
        """Sets the regions of this CloudAccountAzureSpecification.

        A set of regions to enable provisioning on.Refer to /iaas/api/cloud-accounts/region-enumeration.  # noqa: E501

        :param regions: The regions of this CloudAccountAzureSpecification.  # noqa: E501
        :type: list[IaasapicloudaccountsvsphereRegions]
        """
        if regions is None:
            raise ValueError("Invalid value for `regions`, must not be `None`")  # noqa: E501

        self._regions = regions

    @property
    def create_default_zones(self):
        """Gets the create_default_zones of this CloudAccountAzureSpecification.  # noqa: E501

        Create default cloud zones for the enabled regions.  # noqa: E501

        :return: The create_default_zones of this CloudAccountAzureSpecification.  # noqa: E501
        :rtype: bool
        """
        return self._create_default_zones

    @create_default_zones.setter
    def create_default_zones(self, create_default_zones):
        """Sets the create_default_zones of this CloudAccountAzureSpecification.

        Create default cloud zones for the enabled regions.  # noqa: E501

        :param create_default_zones: The create_default_zones of this CloudAccountAzureSpecification.  # noqa: E501
        :type: bool
        """

        self._create_default_zones = create_default_zones

    @property
    def tags(self):
        """Gets the tags of this CloudAccountAzureSpecification.  # noqa: E501

        A set of tag keys and optional values to set on the Cloud Account  # noqa: E501

        :return: The tags of this CloudAccountAzureSpecification.  # noqa: E501
        :rtype: list[IaasapistorageprofilesidTags]
        """
        return self._tags

    @tags.setter
    def tags(self, tags):
        """Sets the tags of this CloudAccountAzureSpecification.

        A set of tag keys and optional values to set on the Cloud Account  # noqa: E501

        :param tags: The tags of this CloudAccountAzureSpecification.  # noqa: E501
        :type: list[IaasapistorageprofilesidTags]
        """

        self._tags = tags

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CloudAccountAzureSpecification, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CloudAccountAzureSpecification):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
